
import java.io.*;
import java.util.*;
import java.lang.*;
import BlowfishJ.*;

/**
  * testing the Blowfish encryption algorithm classes
  * @author Markus Hahn <markus_hahn@gmx.net>
  * @version February 14, 2002
  */

public class BlowfishTest 
{
     // max. size of message to encrypt

     final static int MAX_MESS_SIZE = 256;


     /**
       * the application entry point
       */
     public static void main(String args[])
     {
 
           if (!BlowfishECB.selfTest()) 
	   {
             System.out.println(",selftest failed");
             return;
    	   }
           System.out.println(", passed.");

           // create our test key (simulate an SHA-1 digest)

           String $key = "123456789";
           
	   String $keyByte = $key.getBytes();      
           // do the key-setups
  
           BlowfishECB bfecb = new BlowfishECB(testkey);
  
           System.out.println(", done.\n");

       
           // get a message

           System.out.print("something to encrypt please >");
           System.out.flush();

           byte[] tempbuf = new byte[MAX_MESS_SIZE];
           int nMessSize = 0;
           try 
	   { 
             nMessSize = System.in.read(tempbuf) - 2; 
           }
           catch (java.io.IOException ioe) 
	   { 
             return; 
           }

           // align to the next 8 byte border

           byte[] messbuf;
           int nRest = nMessSize & 7;
           if (nRest != 0) 
           {
             messbuf = new byte[(nMessSize & (~7)) + 8];
             System.arraycopy(tempbuf, 0, messbuf, 0, nMessSize);

             for (int nI = nMessSize; nI < messbuf.length ; nI++) 
             {
               messbuf[nI] = 0x20;
             }
 
             System.out.println("message with " + nMessSize + " bytes aligned to " + 
                                messbuf.length + " bytes");
           }
           else 
           {
             messbuf = new byte[nMessSize];

             System.arraycopy(tempbuf, 0, messbuf, 0, nMessSize);
           }


           // ECB encryption/decryption test...

           bfecb.encrypt(messbuf);

           // show the result

           System.out.println("ECB encrypted message: " + BinConverter.bytesToBinHex(messbuf));

           bfecb.decrypt(messbuf);

           System.out.println("ECB decrypted message: >>>" + new String(messbuf) + "<<<");

           bfecb.cleanUp();
     }
}

